package denim;

/**
 * Created by Work on 27/10/2016.
 */

import beast.core.*;
import beast.core.parameter.RealParameter;
import beast.evolution.tree.Tree;

import java.util.List;
import java.util.Random;

public class GtreeWithEmbedding extends Distribution {
    @SuppressWarnings({"CanBeFinal", "WeakerAccess"})
    public Input<Tree> gtree =
            new Input<Tree>("tree",
                    "A gene tree",
                    Input.Validate.REQUIRED);

    @SuppressWarnings("CanBeFinal")
    public Input<Double> coalFactor =
            new Input<Double>("Ploidy",
                    "Coalescence factor, often the same as ploidy. Default is 2.",
                    2.0);

    public Input<RealParameter> migPoints =
            new Input<RealParameter>("migrationPoints",
                    "The positions along branches at which migrations may occur.",
                    Input.Validate.REQUIRED);


    public Input<RealParameter> destinationChoices =
            new Input<>("destinationChoices",
                    "Numbers which specify which child branches of each internal node specify the destination of a migration.",
                    Input.Validate.REQUIRED);


    @Override
    public List<String> getArguments() {
        return null;
    }

    @Override
    public List<String> getConditions() {
        return null;
    }

    @Override
    public void sample(State state, Random random) {

    }

    @Override
    public void initAndValidate() {
        assert migPoints != null;
        assert migPoints.get() != null;
        int inc = getTree().getInternalNodeCount();
        migPoints.get().setDimension(inc);
        destinationChoices.get().setDimension(inc);
    }

    public Tree getTree() {
        return gtree.get();
    }

    public double getMigPoint(int idx) {
        return migPoints.get().getValue(idx);
    }

    public double getDestinationChoice(int idx) {
        return destinationChoices.get().getValue(idx);
    }

    public double getCoalFactor() {
        return coalFactor.get();
    }
}

